Index: drivers/dahdi/xpp/xpp_dahdi.c
===================================================================
--- drivers/dahdi/xpp/xpp_dahdi.c	(revision 6481)
+++ drivers/dahdi/xpp/xpp_dahdi.c	(working copy)
@@ -190,14 +190,12 @@ static int xpd_proc_create(xbus_t *xbus, xpd_t *xp
 		XPD_ERR(xpd, "Failed to create proc file '%s'\n", PROC_XPD_SUMMARY);
 		goto err;
 	}
-	xpd->proc_xpd_summary->owner = THIS_MODULE;
 #ifdef	OLD_PROC
 	xpd->proc_xpd_ztregister = create_proc_entry(PROC_XPD_ZTREGISTER, 0644, xpd->proc_xpd_dir);
 	if (!xpd->proc_xpd_ztregister) {
 		XPD_ERR(xpd, "Failed to create proc file '%s'\n", PROC_XPD_ZTREGISTER);
 		goto err;
 	}
-	xpd->proc_xpd_ztregister->owner = THIS_MODULE;
 	xpd->proc_xpd_ztregister->data = xpd;
 	xpd->proc_xpd_ztregister->read_proc = proc_xpd_ztregister_read;
 	xpd->proc_xpd_ztregister->write_proc = proc_xpd_ztregister_write;
@@ -206,7 +204,6 @@ static int xpd_proc_create(xbus_t *xbus, xpd_t *xp
 		XPD_ERR(xpd, "Failed to create proc file '%s'\n", PROC_XPD_BLINK);
 		goto err;
 	}
-	xpd->proc_xpd_blink->owner = THIS_MODULE;
 	xpd->proc_xpd_blink->data = xpd;
 	xpd->proc_xpd_blink->read_proc = proc_xpd_blink_read;
 	xpd->proc_xpd_blink->write_proc = proc_xpd_blink_write;
Index: drivers/dahdi/xpp/card_bri.c
===================================================================
--- drivers/dahdi/xpp/card_bri.c	(revision 6481)
+++ drivers/dahdi/xpp/card_bri.c	(working copy)
@@ -602,7 +602,6 @@ static int bri_proc_create(xbus_t *xbus, xpd_t *xp
 		XPD_ERR(xpd, "Failed to create proc file '%s'\n", PROC_BRI_INFO_FNAME);
 		goto err;
 	}
-	priv->bri_info->owner = THIS_MODULE;
 #endif
 	return 0;
 err:
Index: drivers/dahdi/xpp/card_pri.c
===================================================================
--- drivers/dahdi/xpp/card_pri.c	(revision 6481)
+++ drivers/dahdi/xpp/card_pri.c	(working copy)
@@ -421,7 +421,6 @@ static int pri_proc_create(xbus_t *xbus, xpd_t *xp
 		XPD_ERR(xpd, "Failed to create proc '%s'\n", PROC_PRI_INFO_FNAME);
 		goto err;
 	}
-	priv->pri_info->owner = THIS_MODULE;
 	priv->pri_info->write_proc = proc_pri_info_write;
 	priv->pri_info->read_proc = proc_pri_info_read;
 	priv->pri_info->data = xpd;
Index: drivers/dahdi/xpp/card_fxo.c
===================================================================
--- drivers/dahdi/xpp/card_fxo.c	(revision 6481)
+++ drivers/dahdi/xpp/card_fxo.c	(working copy)
@@ -405,7 +405,6 @@ static int fxo_proc_create(xbus_t *xbus, xpd_t *xp
 		XPD_ERR(xpd, "Failed to create proc file '%s'\n", PROC_FXO_INFO_FNAME);
 		goto err;
 	}
-	priv->fxo_info->owner = THIS_MODULE;
 #ifdef	WITH_METERING
 	XPD_DBG(PROC, xpd, "Creating Metering tone file\n");
 	priv->meteringfile = create_proc_read_entry(PROC_METERING_FNAME, 0444, xpd->proc_xpd_dir,
@@ -414,7 +413,6 @@ static int fxo_proc_create(xbus_t *xbus, xpd_t *xp
 		XPD_ERR(xpd, "Failed to create proc file '%s'\n", PROC_METERING_FNAME);
 		goto err;
 	}
-	priv->meteringfile->owner = THIS_MODULE;
 #endif
 #endif
 	return 0;
Index: drivers/dahdi/xpp/card_fxs.c
===================================================================
--- drivers/dahdi/xpp/card_fxs.c	(revision 6481)
+++ drivers/dahdi/xpp/card_fxs.c	(working copy)
@@ -358,7 +358,6 @@ static int fxs_proc_create(xbus_t *xbus, xpd_t *xp
 		XPD_ERR(xpd, "Failed to create proc file '%s'\n", PROC_FXS_INFO_FNAME);
 		goto err;
 	}
-	priv->fxs_info->owner = THIS_MODULE;
 #ifdef	WITH_METERING
 	XPD_DBG(PROC, xpd, "Creating Metering tone file\n");
 	priv->meteringfile = create_proc_entry(PROC_METERING_FNAME, 0200, xpd->proc_xpd_dir);
@@ -366,7 +365,6 @@ static int fxs_proc_create(xbus_t *xbus, xpd_t *xp
 		XPD_ERR(xpd, "Failed to create proc file '%s'\n", PROC_METERING_FNAME);
 		goto err;
 	}
-	priv->meteringfile->owner = THIS_MODULE;
 	priv->meteringfile->write_proc = proc_xpd_metering_write;
 	priv->meteringfile->read_proc = NULL;
 	priv->meteringfile->data = xpd;
Index: drivers/dahdi/xpp/xbus-core.c
===================================================================
--- drivers/dahdi/xpp/xbus-core.c	(revision 6481)
+++ drivers/dahdi/xpp/xbus-core.c	(working copy)
@@ -1088,7 +1088,6 @@ static struct xbus_workqueue *worker_new(int xbusn
 			XBUS_ERR(xbus, "Failed to create proc file '%s'\n", PROC_XBUS_WAITFOR_XPDS);
 			goto err;
 		}
-		worker->proc_xbus_waitfor_xpds->owner = THIS_MODULE;
 	}
 #endif
 #endif
@@ -1384,7 +1383,6 @@ xbus_t *xbus_new(struct xbus_ops *ops, ushort max_
 		err = -EIO;
 		goto nobus;
 	}
-	xbus->proc_xbus_summary->owner = THIS_MODULE;
 #ifdef	PROTOCOL_DEBUG
 	xbus->proc_xbus_command = create_proc_entry(PROC_XBUS_COMMAND, 0200, xbus->proc_xbus_dir);
 	if (!xbus->proc_xbus_command) {
@@ -1394,7 +1392,6 @@ xbus_t *xbus_new(struct xbus_ops *ops, ushort max_
 	}
 	xbus->proc_xbus_command->write_proc = proc_xbus_command_write;
 	xbus->proc_xbus_command->data = xbus;
-	xbus->proc_xbus_command->owner = THIS_MODULE;
 #endif
 #endif
 #ifdef	XPP_DEBUGFS
@@ -1842,7 +1839,6 @@ int __init xbus_core_init(void)
 		ret = -EFAULT;
 		goto err;
 	}
-	proc_xbuses->owner = THIS_MODULE;
 #endif
 #ifdef	XPP_DEBUGFS
 	DBG(GENERAL, "Creating debugfs xpp root\n");
Index: drivers/dahdi/xpp/card_global.c
===================================================================
--- drivers/dahdi/xpp/card_global.c	(revision 6481)
+++ drivers/dahdi/xpp/card_global.c	(working copy)
@@ -403,7 +403,6 @@ int chip_proc_create(xbus_t *xbus, xpd_t *xpd)
 		XPD_ERR(xpd, "Failed to create proc file '%s'\n", CHIP_REGISTERS);
 		goto err;
 	}
-	xpd->proc_xpd_chipregs->owner = THIS_MODULE;
 	xpd->proc_xpd_chipregs->write_proc = proc_xpd_register_write;
 	xpd->proc_xpd_chipregs->read_proc = proc_xpd_register_read;
 	xpd->proc_xpd_chipregs->data = xpd;
Index: drivers/dahdi/xpp/xpp_usb.c
===================================================================
--- drivers/dahdi/xpp/xpp_usb.c	(revision 6481)
+++ drivers/dahdi/xpp/xpp_usb.c	(working copy)
@@ -755,7 +755,6 @@ static int xusb_probe(struct usb_interface *interf
 		retval = -EIO;
 		goto probe_failed;
 	}
-	procsummary->owner = THIS_MODULE;
 #endif
 	bus_count++;
 	xusb->xbus_num = xbus->num;