Index: drivers/dahdi/xpp/mmapbus.c
===================================================================
--- drivers/dahdi/xpp/mmapbus.c	(revision 6635)
+++ drivers/dahdi/xpp/mmapbus.c	(working copy)
@@ -5,7 +5,7 @@
 
 static int mmap_match(struct device *dev, struct device_driver *driver)
 {
-	return !strncmp(dev->bus_id, driver->name, strlen(driver->name));
+	return !strncmp(dev_name(dev), driver->name, strlen(driver->name));
 }
 static int mmap_uevent(struct device *dev, char **envp, int num_envp, char *buffer, int buffer_size)
 {
Index: drivers/dahdi/xpp/card_bri.c
===================================================================
--- drivers/dahdi/xpp/card_bri.c	(revision 6635)
+++ drivers/dahdi/xpp/card_bri.c	(working copy)
@@ -1761,7 +1761,7 @@ static int bri_xpd_probe(struct device *dev)
 	/* Is it our device? */
 	if(xpd->type != XPD_TYPE_BRI) {
 		XPD_ERR(xpd, "drop suggestion for %s (%d)\n",
-			dev->bus_id, xpd->type);
+			dev_name(dev), xpd->type);
 		return -EINVAL;
 	}
 	XPD_DBG(DEVICES, xpd, "SYSFS\n");
Index: drivers/dahdi/xpp/card_pri.c
===================================================================
--- drivers/dahdi/xpp/card_pri.c	(revision 6635)
+++ drivers/dahdi/xpp/card_pri.c	(working copy)
@@ -2085,7 +2085,7 @@ static int pri_xpd_probe(struct device *dev)
 	/* Is it our device? */
 	if(xpd->type != XPD_TYPE_PRI) {
 		XPD_ERR(xpd, "drop suggestion for %s (%d)\n",
-			dev->bus_id, xpd->type);
+			dev_name(dev), xpd->type);
 		return -EINVAL;
 	}
 	XPD_DBG(DEVICES, xpd, "SYSFS\n");
Index: drivers/dahdi/xpp/card_fxo.c
===================================================================
--- drivers/dahdi/xpp/card_fxo.c	(revision 6635)
+++ drivers/dahdi/xpp/card_fxo.c	(working copy)
@@ -1351,7 +1351,7 @@ static int fxo_xpd_probe(struct device *dev)
 	/* Is it our device? */
 	if(xpd->type != XPD_TYPE_FXO) {
 		XPD_ERR(xpd, "drop suggestion for %s (%d)\n",
-			dev->bus_id, xpd->type);
+			dev_name(dev), xpd->type);
 		return -EINVAL;
 	}
 	XPD_DBG(DEVICES, xpd, "SYSFS\n");
Index: drivers/dahdi/xpp/xbus-sysfs.c
===================================================================
--- drivers/dahdi/xpp/xbus-sysfs.c	(revision 6635)
+++ drivers/dahdi/xpp/xbus-sysfs.c	(working copy)
@@ -279,7 +279,7 @@ static struct device_attribute xbus_dev_attrs[] =
 static int astribank_match(struct device *dev, struct device_driver *driver)
 {
 	DBG(DEVICES, "SYSFS MATCH: dev->bus_id = %s, driver->name = %s\n",
-		dev->bus_id, driver->name);
+		dev_name(dev), driver->name);
 	return 1;
 }
 
@@ -326,7 +326,7 @@ static int astribank_uevent(struct device *dev, ch
 	if(!dev)
 		return -ENODEV;
 	xbus = dev_to_xbus(dev);
-	DBG(GENERAL, "SYFS bus_id=%s xbus=%s\n", dev->bus_id, xbus->busname);
+	DBG(GENERAL, "SYFS bus_id=%s xbus=%s\n", dev_name(dev), xbus->busname);
 	XBUS_VAR_BLOCK;
 	envp[i] = NULL;
 	return 0;
@@ -348,7 +348,7 @@ static int astribank_uevent(struct device *dev, st
 	if(!dev)
 		return -ENODEV;
 	xbus = dev_to_xbus(dev);
-	DBG(GENERAL, "SYFS bus_id=%s xbus=%s\n", dev->bus_id, xbus->busname);
+	DBG(GENERAL, "SYFS bus_id=%s xbus=%s\n", dev_name(dev), xbus->busname);
 	XBUS_VAR_BLOCK;
 	return 0;
 }
@@ -363,7 +363,7 @@ void astribank_uevent_send(xbus_t *xbus, enum kobj
 
 	kobj = &xbus->astribank.kobj;
 	XBUS_DBG(DEVICES, xbus, "SYFS bus_id=%s action=%d\n",
-		xbus->astribank.bus_id, act);
+		dev_name(&xbus->astribank), act);
 
 #if defined(OLD_HOTPLUG_SUPPORT_269)
 	{
@@ -645,7 +645,7 @@ static int xpd_match(struct device *dev, struct de
 		return 0;
 	}
 	XPD_DBG(DEVICES, xpd, "SYSFS MATCH: type=%d dev->bus_id = %s, driver->name = %s\n",
-		xpd->type, dev->bus_id, driver->name);
+		xpd->type, dev_name(dev), driver->name);
 	return 1;
 }
 
@@ -701,8 +701,8 @@ int xpd_device_register(xbus_t *xbus, xpd_t *xpd)
 	XPD_DBG(DEVICES, xpd, "SYSFS\n");
 	dev->bus = &xpd_type;
 	dev->parent = &xbus->astribank;
-	snprintf(dev->bus_id, BUS_ID_SIZE, "%02d:%1x:%1x",
-		xbus->num, xpd->addr.unit, xpd->addr.subunit);
+	dev_set_name(dev, "%02d:%1x:%1x", xbus->num, xpd->addr.unit, 
+			xpd->addr.subunit);
 	dev->driver_data = xpd;
 	dev->release = xpd_release;
 	ret = device_register(dev);
@@ -759,7 +759,7 @@ int xbus_sysfs_create(xbus_t *xbus)
 	XBUS_DBG(DEVICES, xbus, "\n");
 	astribank->bus = &toplevel_bus_type;
 	astribank->parent = xbus->transport.transport_device;
-	snprintf(astribank->bus_id, BUS_ID_SIZE, "xbus-%02d", xbus->num);
+	dev_set_name(astribank, "xbus-%02d", xbus->num);
 	astribank->driver_data = xbus;
 	astribank->release = astribank_release;
 	ret = device_register(astribank);
Index: drivers/dahdi/xpp/card_fxs.c
===================================================================
--- drivers/dahdi/xpp/card_fxs.c	(revision 6635)
+++ drivers/dahdi/xpp/card_fxs.c	(working copy)
@@ -1502,7 +1502,7 @@ static int fxs_xpd_probe(struct device *dev)
 	/* Is it our device? */
 	if(xpd->type != XPD_TYPE_FXS) {
 		XPD_ERR(xpd, "drop suggestion for %s (%d)\n",
-			dev->bus_id, xpd->type);
+			dev_name(dev), xpd->type);
 		return -EINVAL;
 	}
 	XPD_DBG(DEVICES, xpd, "SYSFS\n");
Index: drivers/dahdi/xpp/xdefs.h
===================================================================
--- drivers/dahdi/xpp/xdefs.h	(revision 6635)
+++ drivers/dahdi/xpp/xdefs.h	(working copy)
@@ -136,6 +136,12 @@ typedef unsigned char		byte;
 		ssize_t name(struct device *dev, const char *buf, size_t count)
 #endif
 
+#if LINUX_VERSION_CODE < KERNEL_VERSION(2,6,26)
+#define dev_name(dev)		(dev)->bus_id
+#define dev_set_name(dev, format, ...) \
+	snprintf((dev)->bus_id, BUS_ID_SIZE, format, ## __VA_ARGS__);
+#endif
+
 #if LINUX_VERSION_CODE < KERNEL_VERSION(2,6,19)
 /* Also don't define this for later RHEL >= 5.2 . hex_asc is from the 
  * same linux-2.6-net-infrastructure-updates-to-mac80211-iwl4965.patch